# PySonicPlayAudio

# To run this demo, I had to download FMOD, unzip it and copy the file fmod.dll
# into the directory of this Python program.
# I also had to download and install PySonic, using a special distribution
# that installs over Python 2.5.  I found it here:
# http://sourceforge.net/forum/forum.php?thread_id=1695648&forum_id=395208

# Now this module supports the playing of audio clips in PRIME games.
# It is designed to start, pause, and resume music according to the
# filename given.  When a music clip is started, the audio source object
# is hashed (and cached) using the filename as the key.
# If another clip is started before the first finishes, the first is
# "paused" and the second is started.  If the first is requested again,
# it is looked up in the hash and it resumes where it left off.

# Testing has been limited so far, but it seems to work at least with
# short clips.
#  S. Tanimoto, Sept. 18, 2007.


import pySonic
import time

def finished_stream(source):
    print 'Stream finished playing'

SOURCES = {}
CURRENT = None
def play_audio_file(filename):
    print "Trying to play file: "+filename
    global CURRENT, SOURCES
    if CURRENT:
        CURRENT.Pause()
    try:
        existing = SOURCES[filename]
        existing.Play()
        CURRENT = existing
    except:
        new_src = pySonic.Source()
        new_src.Sound = pySonic.FileStream(filename)
        new_src.Position = (-0.5, 0.0, 0.5) # Position in 3D space
        new_src.SetEndStreamCallback(finished_stream)
        SOURCES[filename]=new_src
        CURRENT = new_src
        new_src.Play()

def pause_audio():
    global CURRENT
    if CURRENT:
        CURRENT.Pause()
        
# initialize the audio environment
w = pySonic.World()

if __name__ == '__main__':
  try:
    play_audio_file("C:/Documents and Settings/Tanimoto/My Documents/PRIME-Stuff/samplePrime/chimes.wav")
    #play_audio_file("C:/Python25/Media-for-PRIME-Games/mozart40th.mid")
    for i in range(5):
        time.sleep(1)
        pause_audio()
        time.sleep(1)
        global CURRENT
        CURRENT.Play()
    CURRENT.Stop()
  except: CURRENT.Stop()
  
      
  
